let songsData;
/*  Load JSON   */
var hostAddress = window.location.origin;
// fetch('http://192.168.225.21:7077/songs')
fetch(hostAddress+'/songs')
            .then(function (response) {
                return response.json();
            })
            .then(function (data) {
                console.log('Recieved');
                songsData = data;
                appendData(data.songs);
                initAmplitude();
            })
            .catch(function (err) {
                console.log('error: ' + err);
            });

function appendData(data) {
    const mainContainer = document.getElementById("amplitude-right");
    // var   linebreak = document.createElement("br");
    for (let i = 0; i < data.length; i++) {
        const songname = data[i].name;
        const Songartist = data[i].artist;

        const songslist = document.createElement("div");
        const nowplaying = document.createElement("div");
        const playbutton = document.createElement("div");
        const image = document.createElement("img");
        const metadata = document.createElement("div");
        const spnsongtitle = document.createElement("span");
        const spnsongartist = document.createElement("span");

        songslist.setAttribute("class", "song amplitude-song-container amplitude-play-pause");
        songslist.setAttribute("data-amplitude-song-index", ""+i)
        songslist.setAttribute("style", "background-color: rgb(255, 255, 255);")
        nowplaying.setAttribute("class", "song-now-playing-icon-container");
        playbutton.setAttribute("class", "play-button-container");
        image.setAttribute("class", "now-playing");
        image.setAttribute("src", "./img/now-playing.svg");
        metadata.setAttribute("class", "song-meta-data");
        spnsongtitle.setAttribute("class", "song-title");
        spnsongartist.setAttribute("class", "song-artist");
        spnsongtitle.setAttribute("class", "song-title");
        spnsongartist.setAttribute("class", "song-artist");

         spnsongtitle.innerHTML = songname;
         spnsongartist.innerHTML = Songartist;

        nowplaying.appendChild(playbutton);
        nowplaying.appendChild(image);
        songslist.appendChild(nowplaying);
        metadata.appendChild(spnsongtitle);
        metadata.appendChild(spnsongartist);
        songslist.appendChild(metadata);
        mainContainer.appendChild(songslist);
    }
        setList();
}

/*
  When the bandcamp link is pressed, stop all propagation so AmplitudeJS doesn't
  play the song.
*/
let bandcampLinks = document.getElementsByClassName('bandcamp-link');

for(let i = 0; i < bandcampLinks.length; i++ ){
  bandcampLinks[i].addEventListener('click', function(e){
    e.stopPropagation();
  });
}

function setList() {
    let songElements = document.getElementsByClassName('song');

    for(let i = 0; i < songElements.length; i++ ){
      /*
        Ensure that on mouseover, CSS styles don't get messed up for active songs.
      */
      songElements[i].addEventListener('mouseover', function(){
        this.style.backgroundColor = '#00A0FF';

        this.querySelectorAll('.song-meta-data .song-title')[0].style.color = '#FFFFFF';
        this.querySelectorAll('.song-meta-data .song-artist')[0].style.color = '#FFFFFF';

        if( !this.classList.contains('amplitude-active-song-container') ){
          this.querySelectorAll('.play-button-container')[0].style.display = 'block';
        }
      });

      /*
        Ensure that on mouseout, CSS styles don't get messed up for active songs.
      */
      songElements[i].addEventListener('mouseout', function(){
        this.style.backgroundColor = '#FFFFFF';
        this.querySelectorAll('.song-meta-data .song-title')[0].style.color = '#272726';
        this.querySelectorAll('.song-meta-data .song-artist')[0].style.color = '#607D8B';
        this.querySelectorAll('.play-button-container')[0].style.display = 'none';
      });

      /*
        Show and hide the play button container on the song when the song is clicked.
      */
      songElements[i].addEventListener('click', function(){
        this.querySelectorAll('.play-button-container')[0].style.display = 'none';
      });
    }
}

/*
  Initializes AmplitudeJS
*/
function initAmplitude() {
    Amplitude.init(songsData);
    document.getElementById('large-visualization').style.height = document.getElementById('album-art').offsetWidth + 'px';
}